package com.steerinfo.baseinfo.meterbaserailwayweight.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbaserailwayweight.model.MeterBaseRailwayWeight;
import com.steerinfo.baseinfo.meterbaserailwayweight.service.IMeterBaseRailwayWeightService;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import oracle.jdbc.proxy.annotation.Post;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseRailwayWeight RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-10-17 04:53
 * 类描述
 * 修订历史：
 * 日期：2020-10-17
 * 作者：generator
 * 参考：
 * 描述：MeterBaseRailwayWeight RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbaserailwayweights")
@Api(value = "/${api.version}/meterbaserailwayweights", tags = "火车车厢期限皮重 - MeterBaseRailwayWeightController")
public class MeterBaseRailwayWeightController extends BaseRESTfulController {

    @Autowired
    IMeterBaseRailwayWeightService meterBaseRailwayWeightService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserailwayweight:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseRailwayWeight> list = meterBaseRailwayWeightService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserailwayweight:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseRailwayWeight> list = meterBaseRailwayWeightService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserailwayweight:view")
    @PostMapping(value = "/noPage")
    public RESTfulResult noPage(@RequestBody HashMap parmas) {
        try {
            List<MeterBaseRailwayWeight> list = meterBaseRailwayWeightService.queryLike(parmas);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseRailwayWeight对象创建")
    @ApiImplicitParam(name = "meterBaseRailwayWeight", value = "详细实体meterBaseRailwayWeight", required = true, dataType = "MeterBaseRailwayWeight")
    //@RequiresPermissions("meterbaserailwayweight:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseRailwayWeight model) {
        try {
            MeterBaseRailwayWeight meterBaseRailwayWeight = meterBaseRailwayWeightService.add(model);
            return success(meterBaseRailwayWeight);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaserailwayweight:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseRailwayWeight meterBaseRailwayWeight = meterBaseRailwayWeightService.getById(id);
            return success(meterBaseRailwayWeight);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseRailwayWeight信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseRailwayWeight", value = "详细实体meterBaseRailwayWeight", required = true, dataType = "MeterBaseRailwayWeight")
    })
    //@RequiresPermissions("meterbaserailwayweight:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseRailwayWeight model) {
        try {
            model.setId(id);
            MeterBaseRailwayWeight meterBaseRailwayWeight = meterBaseRailwayWeightService.modify(model);
            return success(meterBaseRailwayWeight);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaserailwayweight:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterBaseRailwayWeightService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "根据车号获取轨道衡的皮重数据", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    @GetMapping(value = "/selectTo")
    public RESTfulResult selectTo(@RequestParam String railwayNo, String flag, Integer pageNum, Integer pageSize) {
        RESTfulResult rm = failed();
        try {
            PageHelper.startPage(pageNum, pageSize);
            List<MeterBaseRailwayWeight> rows = meterBaseRailwayWeightService.selectTo(railwayNo, flag);
            PageList pageInfo = new PageList(rows);
            return success(pageInfo);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        }
        return rm;
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseRailwayWeight对象创建")
    @ApiImplicitParam(name = "meterBaseRailwayWeight", value = "详细实体meterBaseRailwayWeight", required = true, dataType = "MeterBaseRailwayWeight")
    //@RequiresPermissions("meterbaserailwayweight:create")
    @PostMapping(value = "/add")
    public RESTfulResult checkandadd(@RequestBody MeterBaseRailwayWeight model) {
        RESTfulResult rm = failed();
        try {
            MeterBaseRailwayWeight mbrw = meterBaseRailwayWeightService.checkandadd(model);
            if (mbrw != null) {
                return success(mbrw);
            } else {
                return failed("操作失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "修改", notes = "根据MeterBaseRailwayWeight对象修改")
    @ApiImplicitParam(name = "meterBaseRailwayWeight", value = "详细实体meterBaseRailwayWeight", required = true, dataType = "MeterBaseRailwayWeight")
    //@RequiresPermissions("meterbaserailwayweight:create")
    @PostMapping(value = "/update")
    public RESTfulResult checkandupdate(@RequestBody MeterBaseRailwayWeight model) {
        RESTfulResult rm = failed();
        try {
            int num = meterBaseRailwayWeightService.checkandupdate(model);
            if (num == 1) {
                return success(num);
            } else {
                return failed("操作失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "删除/停用", notes = "根据MeterBaseRailwayWeight对象停用")
    @ApiImplicitParam(name = "meterBaseRailwayWeight", value = "详细实体meterBaseRailwayWeight", required = true, dataType = "MeterBaseRailwayWeight")
    //@RequiresPermissions("meterbaserailwayweight:create")
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody List<MeterBaseRailwayWeight> models) {
        RESTfulResult rm = failed();
        try {
            int num = meterBaseRailwayWeightService.abolish(models);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("操作失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "启用", notes = "根据MeterBaseRailwayWeight对象启用")
    @ApiImplicitParam(name = "meterBaseRailwayWeight", value = "详细实体meterBaseRailwayWeight", required = true, dataType = "MeterBaseRailwayWeight")
    //@RequiresPermissions("meterbaserailwayweight:create")
    @PostMapping(value = "/recover")
    public RESTfulResult recover(@RequestBody List<MeterBaseRailwayWeight> models) {
        RESTfulResult rm = failed();
        try {
            int num = meterBaseRailwayWeightService.recover(models);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("操作失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    //==========================================eason add 2021-04-01========================
    @ApiOperation(value = "动态轨道衡保存期限皮重", notes = "动态轨道衡保存期限皮重")
    @ApiImplicitParam(name = "meterBaseRailwayWeight", value = "详细实体meterBaseRailwayWeight", required = true, dataType = "MeterBaseRailwayWeight")
    //@RequiresPermissions("meterbaserailwayweight:create")
    @PostMapping(value = "/doSaveWf")
    public RESTfulResult doSaveWf(@RequestBody List<MeterBaseRailwayWeight> models) {
        RESTfulResult rm = failed();
        try {
            int num = meterBaseRailwayWeightService.doSaveWf(models);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("操作失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }
}
